-------------------------------------------------------------
-- square table rom
-------------------------------------------------------------
library ieee;
use ieee.std_logic_1164.all;

entity romSq is 
        port(   a : in std_logic_vector(3 downto 0);
                o : out std_logic_vector(7 downto 0));
end romSq;

architecture rtl of romSq is

        signal data15 : std_logic_vector(7 downto 0);
        signal data14 : std_logic_vector(7 downto 0);
        signal data13 : std_logic_vector(7 downto 0);
        signal data12 : std_logic_vector(7 downto 0);
        signal data11 : std_logic_vector(7 downto 0);
        signal data10 : std_logic_vector(7 downto 0);
        signal data9  : std_logic_vector(7 downto 0);
        signal data8  : std_logic_vector(7 downto 0);
        signal data7  : std_logic_vector(7 downto 0);
        signal data6  : std_logic_vector(7 downto 0);
        signal data5  : std_logic_vector(7 downto 0);
        signal data4  : std_logic_vector(7 downto 0);
        signal data3  : std_logic_vector(7 downto 0);
        signal data2  : std_logic_vector(7 downto 0);
        signal data1  : std_logic_vector(7 downto 0);
        signal data0  : std_logic_vector(7 downto 0);

begin

--                              address / data
        data15 <= "11100001";   -- 0Fh  E1h...225d
        data14 <= "11000100";   -- 0Eh  C4h...196d
        data13 <= "10101001";   -- 0Dh  A9h...169d
        data12 <= "10010000";   -- 0Ch  90h...144d
        data11 <= "01111001";   -- 0Bh  79h...121d
        data10 <= "01100100";   -- 0Ah  64h...100d
        data9  <= "01010001";   -- 09h  51h... 81d
        data8  <= "01000000";   -- 08h  40h... 64d
        data7  <= "00110001";   -- 07h  31h... 49d
        data6  <= "00100100";   -- 06h  24h... 36d
        data5  <= "00011001";   -- 05h  19h... 25d
        data4  <= "00010000";   -- 04h  10h... 16d
        data3  <= "00001001";   -- 03h  09h...  9d
        data2  <= "00000100";   -- 02h  04h...  4d
        data1  <= "00000001";   -- 01h  01h...  1d
        data0  <= "00000000";   -- 00h  00h...  0d

        with a select
                o <= data15 when "1111",
                     data14 when "1110",
                     data13 when "1101",
                     data12 when "1100",
                     data11 when "1011",
                     data10 when "1010",
                     data9  when "1001",
                     data8  when "1000",
                     data7  when "0111",
                     data6  when "0110",
                     data5  when "0101",
                     data4  when "0100",
                     data3  when "0011",
                     data2  when "0010",
                     data1  when "0001",
                     data0  when "0000",
                     "00000000" when others;

end rtl;

