--
-- add (with carry input) library
--
library ieee;
use ieee.std_logic_1164.all;
package libAdc is
        function adc8(aa,bb : std_logic_vector(7 downto 0);cc : std_logic) return std_logic_vector;
end libAdc;

package body libAdc is
        function adc8(aa,bb : std_logic_vector(7 downto 0);cc : std_logic) return std_logic_vector is
                variable interCarry : std_logic;
                variable temp       : std_logic_vector(aa'high + 1 downto aa'low);
        begin
                interCarry := cc;
                for j in aa'low to aa'high loop
                        temp(j)    := aa(j) xor bb(j) xor interCarry;
                        interCarry := (aa(j) and bb(j)) or ( (aa(j) or bb(j)) and interCarry);
                end loop;
                temp(aa'high + 1) := interCarry;
                return(temp);
        end adc8;
end libAdc;

--
-- adder8 (use function)
--
library ieee;
use ieee.std_logic_1164.all;
use work.libAdc.all;

entity adder8_func is
        port(   a  : in std_logic_vector(7 downto 0);
                b  : in std_logic_vector(7 downto 0);
                ci : in std_logic;
                co : out std_logic;
                s  : out std_logic_vector(7 downto 0) );
end adder8_func;

architecture rtl of adder8_func is

        signal temp : std_logic_vector(8 downto 0);

begin

        temp <= adc8(a,b,ci);

        co <= temp(8);
        s  <= temp(7 downto 0);

end rtl;
