--
-- compare library
--
library ieee;
use ieee.std_logic_1164.all;

package libComp is
        function fEq8(aa,bb : std_logic_vector(7 downto 0) ) return std_logic;
        function fGtb8(aa,bb : std_logic_vector(7 downto 0) ) return std_logic;
end libComp;

package body libComp is
        function fEq8(aa,bb : std_logic_vector(7 downto 0) ) return std_logic is
                variable notEqual : std_logic;
        begin
                notEqual := '0';
                for j in aa'high downto aa'low loop
                        notEqual := notEqual or (aa(j) xor bb(j));
                end loop;
                return(not notEqual);
        end fEq8;

        function fGtb8(aa,bb : std_logic_vector(7 downto 0) ) return std_logic is
                variable compareEndFlag : std_logic;
                variable gtbFlag : std_logic;
        begin
                compareEndFlag := '0';
                gtbFlag := '0';
                for j in aa'high downto aa'low loop
                        if (compareEndFlag = '0') then
                                compareEndFlag := compareEndFlag or (aa(j) xor bb(j));
                                gtbFlag := aa(j) and (not bb(j));
                        end if;
                end loop;
                return(gtbFlag);
        end fGtb8;
end libComp;

--
-- 8-bit comparetor
--
library ieee;
use ieee.std_logic_1164.all;
use work.libComp.all;

entity comp8_func is
        port(   a   : in std_logic_vector(7 downto 0);
                b   : in std_logic_vector(7 downto 0);
                eq  : out std_logic;
                gtb : out std_logic);
end comp8_func;

architecture rtl of comp8_func is

begin

        eq  <= fEq8(a,b);
        gtb <= fGtb8(a,b);

end rtl;



