--
-- decrement library
--
library ieee;
use ieee.std_logic_1164.all;

package libDec is
        function decrement8(source : std_logic_vector(7 downto 0)) return std_logic_vector;
end libDec;

package body libDec is
        function decrement8(source : std_logic_vector(7 downto 0)) return std_logic_vector is
                variable orAll : std_logic;
                variable temp  : std_logic_vector(source'high downto source'low);
        begin
                orAll := '0';
                for j in source'low to source'high loop
                        temp(j) := source(j) xor (not orAll);
                        orAll := orAll or source(j);
                end loop;
                return(temp);
        end decrement8;
end libDec;

--
-- 8-bit down counter with enable (use function)
--
library ieee;
use ieee.std_logic_1164.all;
use work.libDec.all;

entity count8de_func is
        port(   e  : in std_logic;
                c  : in std_logic;
                nr : in std_logic;
                q  : out std_logic_vector(7 downto 0) );
end count8de_func;

architecture rtl of count8de_func is

        signal bufQ : std_logic_vector(7 downto 0);

begin
        process(nr,c)
        begin
                if (nr = '0') then
                        bufQ <= (others => '0');
                elsif (c'event and c = '1') then
                        if (e = '1') then
                                bufQ <= decrement8(bufQ);
                        end if;
                end if;
        end process;

        q <= bufQ;

end rtl;

