--
-- straight sequencer
--
library ieee;
use ieee.std_logic_1164.all;

entity sqA is
        port(   start : in std_logic;
                c     : in std_logic;
                nr    : in std_logic;
                st1   : out std_logic;
                st2   : out std_logic;
                st3   : out std_logic;
                st4   : out std_logic);
end sqA;

architecture rtl of sqA is

        signal nonState : std_logic;
        signal st1In    : std_logic;
        signal stBuf    : std_logic_vector(4 downto 1);

begin

        process(nr,c)
        begin

                if (nr = '0') then
                        stBuf <= (others => '0');
                elsif (c'event and c = '1') then
                        stBuf(4 downto 1) <= stBuf(3 downto 1) & st1In;
                end if;

        end process;

-- start
        nonState <= '1' when (stBuf = "0000") else '0';
        st1In    <= nonState and start;

        st1 <= stBuf(1);
        st2 <= stBuf(2);
        st3 <= stBuf(3);
        st4 <= stBuf(4);

end rtl;
