--
-- sequencer include wait state
--
library ieee;
use ieee.std_logic_1164.all;

entity sqWaitA is
        port(   start : in std_logic;
                ctrl  : in std_logic;
                c     : in std_logic;
                nr    : in std_logic;
                st1   : out std_logic;
                st2   : out std_logic;
                st3   : out std_logic;
                st4   : out std_logic;
                st5   : out std_logic);
end sqWaitA;

architecture rtl of sqWaitA is

        signal nonState : std_logic;
        signal st1In    : std_logic;
        signal st3In    : std_logic;
        signal st4In    : std_logic;
        signal stBuf    : std_logic_vector(5 downto 1);

begin

        process(nr,c)
        begin

                if (nr = '0') then
                        stBuf <= (others => '0');
                elsif (c'event and c = '1') then
                        stBuf(2 downto 1) <= stBuf(1) & st1In;
                        stBuf(3)          <= st3In;
                        stBuf(5 downto 4) <= stBuf(4) & st4In;
                end if;

        end process;

-- start
        nonState <= '1' when (stBuf = "00000") else '0';
        st1In    <= nonState and start;
-- wait loop
        st3In <= stBuf(2) or (stBuf(3) and (not ctrl) );
-- loop out
        st4In <= stBuf(3) and ctrl;

        st1 <= stBuf(1);
        st2 <= stBuf(2);
        st3 <= stBuf(3);
        st4 <= stBuf(4);
        st5 <= stBuf(5);

end rtl;
