--
-- 4-bit shift-reg. with synchronous parallel load & enable
--
library ieee;
use ieee.std_logic_1164.all;

entity sr4le is
        port(   d  : in std_logic_vector(3 downto 0);   -- parallel load data
                l  : in std_logic;                      -- paralell load
                si : in std_logic;                      -- serial input data
                e  : in std_logic;                      -- shift enable
                c  : in std_logic;
                nr : in std_logic;
                q  : out std_logic_vector(3 downto 0) );
end sr4le;

architecture rtl of sr4le is

        signal bufQ : std_logic_vector(3 downto 0);

begin

        process(nr,c)
        begin

                if (nr = '0') then
                        bufQ <= (others => '0');
                elsif (c'event and c = '1') then
                        if (l = '1') then
                                bufQ <= d;
                        elsif (e = '1') then
                                bufQ <= bufQ(2 downto 0) & si;
                        end if;
                end if;

        end process;

        q <= bufQ;

end rtl;

